---
title: POS 3
layout: layouts/base_subject.njk
eleventyNavigation:
  key: POS 3
  parent: POS
  order: 3
---


<h2 id="overview">Course Overview</h2>
<h3 id="content_c">Revision of C</h3>
<ul>
  <li><a href="/presentations/c/file_io/">File I/O</a></li>
  <li><a href="/presentations/c/cli/">Commandline Arguments</a></li>
  <li><a href="/presentations/c/function_pointer/">Function Pointer</a></li>
</ul>

<h3 id="content_oop">Object oriented programming with C++</h3>
<ul>
  <li><a href="/presentations/cpp/introduction/">Introduction to C++</a></li>
  <li><a href="/presentations/cpp/fast_track/">Fast Track to C++ Syntax for
    Programmers</a></li>
  <li><a href="/presentations/cpp/standard_library/containers/">
      Standard Library 1 - Containers</a></li>
  <li><a href="/presentations/cpp/oop/structs/">Introduction to OOP -
    Structs (Composite Data Types)</a></li>
  <li><a href="/presentations/cpp/oop/classes/">Introduction to OOP -
    Classes and Encapsulation</a></li>
  <li><a href="/presentations/cpp/operator_overloading/">Introduction to OOP -
    Operator Overloading</a></li>
  <li><a href="/presentations/cpp/unit_testing/">Unit Testing</a></li>
</ul>

<h3 id="content_gui">GUI Programming</h3>
<ul>
  {# move to docs.find-santa.eu and link to that page #}
  <li><a href="https://www.wxwidgets.org/docs/tutorials/#getting-started">
    Getting started with wxwidgets</a></li>
  <li><a href="https://zetcode.com/gui/wxwidgets/">ZetCode wxWidgets tutorial</a></li>
  <li><a href="https://www.youtube.com/playlist?list=PLFk1_lkqT8MbVOcwEppCPfjGOGhLvcf9G">
    C++ GUI Programming For Beginners (wxWidgets)</a></li>
</ul>

<h3 id="content_general">General Topics</h3>
<ul>
  <li><a href="/presentations/c/algorithms/introduction_to_algorithms/">Introduction to Algorithms</a></li>
  <li><a href="/images/programming/doubly_linked_list.png">Doubly linked list</a></li>
  <li><a href="https://github.com/HTL-Bulme/f2022-pos-3akift-presentations">Student Presentations</a></li>
</ul>


<h2 id="exercises">Programming Exercises</h2>
<h3>Revision of C</h3>
<ul>
  <li><a href="/exercises/c/exercise_files/">Reading and Writing Files in C</a></li>
  <li><a href="/exercises/algorithms/deque/">Deque</a></li>
</ul>

<h3>Git</h3>
<ul>
  <li><a href="https://classroom.github.com/a/2xw6NR3A">Accept Git Assignment 1</a> -
    <a href="/exercises/python/exercise_3/">download grader and tasks</a></li>
</ul>

<h3>Object oriented programming (OOP) with C++</h3>
<ul>
  <li>Intro to OOP - Structs (Composite Data Types):
    <a href="https://classroom.github.com/a/lndNeLkL">Accept GitHub Assignment</a></li>
  {# <li><a href="/exercises/cpp/oop_intro/">Intro to OOP</a></li> #}
  <li><a href="/exercises/cpp/operator_overloading/">C++ Operator Overloading</a></li>
  <li><a href="https://www.hackerrank.com/challenges/c-tutorial-struct/problem">
    Structs</a> (Hackerrank)</li>
  <li><a href="https://www.hackerrank.com/challenges/c-tutorial-class/problem">
    Class</a> (Hackerrank)</li>
  <li><a href="https://www.hackerrank.com/challenges/classes-objects/problem">
    Objects</a> (Hackerrank)</li>
  <li><a href="https://www.hackerrank.com/challenges/box-it/problem">
    Box It!</a> (Hackerrank)</li>
  <li><a href="/exercises/cpp/oop_intro/">Intro to OOP - Classes and
    Encapsulation</a></li>
  <li><a href="/exercises/cpp/oop_inheritance/">OOP - Inheritance</a></li>

</ul>

<h3>Programming Project</h3>
<ul>
  <li><a href="/exercises/cs/initial_oss_contribution/">Initial Open Source
    Contribution Programming Project</a></li>
</ul>

{# <h2 id="exams">Prior Exams</h2>
<ul>
</ul>
#}

<h2 id="links">Links</h2>

<ul>
  <li><a href="http://docs.find-santa.eu/dvcs/">Git notes</a></li>
  <li><a href="https://ndpsoftware.com/git-cheatsheet.html">Git cheatsheet</a></li>
</ul>

{% include 'blocks/code_challenge_sites.njk' %}


<h2 id="lehrstoff">Lehrstoff</h2>

<ul>
  <li>Bereich Programmiergrundlagen
    <ul>
      <li>Statische und dynamische Datenstrukturen einsetzen und den Ablauf der
        wichtigsten Operationen für dynamische Datenstrukturen erklären</li>
      <li>Objektorientierte Konzepte verstehen und anwenden</li>
      <li>Das Konzept der Rekursion und ihre Anwendungsgebiete erklären</li>
    </ul>
  </li>
  <li>Bereich Anwendungsprogrammierung
    <ul>
      <li>Aufgrund der Eigenschaften einiger Programmbibliotheken für gängige
        Aufgaben eine geeignete Auswahl daraus treffen</li>
      <li>Programme mit einer modernen, grafischen Benutzeroberfläche
        entwickeln</li>
    </ul>
  </li>
  <li>Bereich Softwareentwicklungsprozess
    <ul>
      <li>Softwarelösungen für komplexe Systeme mit Hilfe gängiger Tools
        planen</li>
    </ul>
  </li>
</ul>
